> For the complete documentation index, see [llms.txt](https://docs.gamepot.io/llms.txt). Markdown versions of documentation pages are available by appending `.md` to page URLs; this page is available as [Markdown](https://docs.gamepot.io/basics/gamepot-2.0/zhong-wen/troubleshooting/sheng-ji-dao-androidtargetsdkversion-31-yi-shang-shi-chu-xian-yi-xia-cuo-wu-he-ying-yong-wu-fa-an-zh.md).

# 升级到android、targetsdkversion 31以上时，出现以下错误和应用无法安装的问题

```
示例）
Failure [INSTALL_PARSE_FAILED_MANIFEST_MALFORMED: Failed parse during installPackageLI: /data/app/XXXXXXXX.tmp/base.apk (at Binary XML file line #445): io.gamepot.common.GamePotFCMIDService: Targeting S+ (version 31 and above) requires that an explicit value for android:exported be defined when intent filters are present]
```

需要在AndroidManifest.xml内定义android:exported。 需要添加下列语句。/（下列外部使用activty / service / receiver的部分应当按照相关用途进行定义。）

示例）

```
       <service
            android:exported="false"
            android:name="io.gamepot.common.GamePotFCMIDService">
            <intent-filter>
                <action android:name="com.google.firebase.INSTANCE_ID_EVENT"/>
            </intent-filter>
        </service>
        <service
            android:exported="false"
            android:name="io.gamepot.common.GamePotFCMService">
            <intent-filter>
                <action android:name="com.google.firebase.MESSAGING_EVENT"/>
            </intent-filter>
        </service>
        
        <!-- 若不使用ELSA服务，则删除下方语句/构建时不得包含gamepot-logger.aar [start]-->
        <receiver
            android:exported="false"
            android:name="com.navercorp.nelo2.android.util.NetworkStatusReceiver">
            <intent-filter>
                <action android:name="android.net.conn.CONNECTIVITY_CHANGE"/>
            </intent-filter>
        </receiver>
        <!-- 若不使用ELSA服务，则删除下方语句/构建时不得包含gamepot-logger.aar [end]-->
        
        
        <!-- 若不使用NAVER登录，则删除下方语句 [start]-->
        <activity android:exported="true" android:configChanges="orientation|screenSize" android:launchMode="singleTask" android:name="com.nhn.android.naverlogin.ui.OAuthCustomTabActivity" android:theme="@android:style/Theme.Translucent.NoTitleBar">
            <intent-filter>
                <action android:name="android.intent.action.VIEW"/>
                <category android:name="android.intent.category.DEFAULT"/>
                <category android:name="android.intent.category.BROWSABLE"/>
                <data android:host="authorize" android:path="/" android:scheme="naver3rdpartylogin"/>
            </intent-filter>
        </activity>
        <!-- 若不使用NAVER登录，则删除下方语句 [end]-->
```


---

# Agent Instructions
This documentation is published with GitBook. GitBook is the documentation platform designed so that both humans and AI agents can read, navigate, and reason over technical content effectively. Learn more at gitbook.com.

## Querying This Documentation
If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter:

```
GET https://docs.gamepot.io/basics/gamepot-2.0/zhong-wen/troubleshooting/sheng-ji-dao-androidtargetsdkversion-31-yi-shang-shi-chu-xian-yi-xia-cuo-wu-he-ying-yong-wu-fa-an-zh.md?ask=<question>
```

The question should be specific, self-contained, and written in natural language.
The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
